
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>*[?]Lowest Common Ancestor of Two Nodes in a Binary Tree / 憋错料</title>

    <meta name="description" content="*[?]Lowest Common Ancestor of Two Nodes in a Binary Tree Reference: http://blog.csdn.net/v_july_v/article/details/18312089   http://leetcode.com/2011/07/lowest-common-ancestor-of-a-binary-tree-part-ii.html http://www.cnblogs.com/springfor/p/4141924.html (1) Is the tree a BST or not? BST的话,我们就能按照BST的定义思考了.当">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">*[?]Lowest Common Ancestor of Two Nodes in a Binary Tree</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p><strong>Reference：</strong></p>
<p><strong>http://blog.csdn.net/v_july_v/article/details/18312089&nbsp;&nbsp;<br /></strong></p>
<p><strong>http://leetcode.com/2011/07/lowest-common-ancestor-of-a-binary-tree-part-ii.html</strong></p>
<p><strong>http://www.cnblogs.com/springfor/p/4141924.html</strong></p>
<p>(1) Is the tree a BST or not?</p>
<p>BST的话，我们就能按照BST的定义思考了。当前遍历的node如果比我们要找的两个点都大，说明那两个点都在当前node的左边，所以这两个node的祖先肯定在当前node的左边，所以往左边找。反之，往右边找。如果这两个点一个大于当前node一个小于当前node，说明当前node就是LCA。 如果这两个点一个是另一个的祖先，那么这个点就是LCA。</p>
<p>代码如下：</p>
<pre>1 public TreeNode lowestCommonAncestor(TreeNode root, TreeNode p, TreeNode q) {
2         if(p.val &lt; root.val &amp;&amp; q.val &lt; root.val)
3             return lowestCommonAncestor(root.left, p, q);
4         else if(p.val &gt; root.val &amp;&amp; q.val &gt; root.val)
5             return lowestCommonAncestor(root.right, p, q);
6         else
7             return root;
8 }</pre>
<p>（2）那如果不是BST呢？一般Binary Tree.</p>
<p>a. Tree结构中没有parent域。</p>
<p>递归找。</p>
<p>代码如下：</p>
<pre> 1 //Worst case O(n)
 2 Node getLCA(Node root, Node node1, Node node2){
 3         if(root == null)
 4             return null
 5         if(root == node1 || root == node2)
 6             return root;
 7
 8         Node left = getLCA(root.left, node1, node2);
 9         Node right = getLCA(root.right, node1, node2);
10
11         if(left != null &amp;&amp; right != null)
12             return root;
13         else if(left != null)
14             return left;
15         else if(right != null)
16             return right;
17         else
18             return null;
19     }</pre>
<p>b. 如果有parent域。</p>
<p>转化为两个linkedlist的交点问题。</p>
<p>代码如下：</p>
<pre> 1 int getHeight(Node p){
 2         int height = 0;
 3         while(p!=null){
 4             height++;
 5             p = p.parent;
 6         }
 7         return height;
 8     }
 9
10     void swap(int a, int b){
11         a = a + b;
12         b = a - b;
13         a = a - b;
14     }
15
16     Node getLCA(Node p, Node q){
17         int h1 = getHeight(p);
18         int h2 = getHeight(q);
19
20         //q is always deeper than p
21         if(h1 &gt; h2){
22             swap(h1, h2);
23             swap(p, q);
24         }
25
26         int diff = h2 - h1;
27
28         for( int i = 0; i &lt; diff; i++)
29             q = q.parent;
30
31         while(p!=null &amp;&amp; q!=null){
32             //common node
33             if(p == q)
34                 return p;
35             p = p.parent;
36             q = q.parent;
37         }
38
39         return NULL; //p and q are not in the same tree
40     }</pre>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-20 00:19:34 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>*[?]Lowest Common Ancestor of Two Nodes in a Binary Tree的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4pvkAo0.html" rel="bookmark">4&period;7 Lowest Common Ancestor of a Binary Search Tree 二叉树的最小共同父节点</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				4.7 Design an algorithm and write code to find the first common ancestor of two nodes in a binary tree. Avoid storing additional nodes in a data structure. NOTE: This is not necessarily a binary search tree. LeetCode上的原题,请参见我之前的博客Lowest Common Ancest			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/949r8AM.html" rel="bookmark">235&period; Lowest Common Ancestor of a Binary Search Tree</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1. 问题描述 Given a binary search tree (BST), find the lowest common ancestor (LCA) of two given nodes in the BST.According to the definition of LCA on Wikipedia: “The lowest common ancestor is defined between two nodes v and w as the lowest node in T th			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/bMomPB3.html" rel="bookmark">Lowest Common Ancestor of a Binary Search Tree</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1. Title 235. Lowest Common Ancestor of a Binary Search Tree 2. Http address https://leetcode.com/problems/lowest-common-ancestor-of-a-binary-search-tree/ 3. The question Given a binary search tree (BST), find the lowest common ancestor (LCA) of two			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/j4NqoV3.html" rel="bookmark">Lowest Common Ancestor of a Binary Tree</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				题目连接 https://leetcode.com/problems/lowest-common-ancestor-of-a-binary-tree/ Common Ancestor of a Binary Tree Description Given a binary tree, find the lowest common ancestor (LCA) of two given nodes in the tree. According to the definition of LCA on			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MEovdR3.html" rel="bookmark">数据结构与算法&lpar;1&rpar;支线任务4&mdash;&mdash;Lowest Common Ancestor of a Binary Tree</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				题目如下:https://leetcode.com/problems/lowest-common-ancestor-of-a-binary-tree/ Given a binary tree, find the lowest common ancestor (LCA) of two given nodes in the tree. According to the definition of LCA on Wikipedia: “The lowest common ancestor is def			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0eAk2J0.html" rel="bookmark">LeetCode &lpar;236&rpar;&colon;Lowest Common Ancestor of a Binary Search Tree</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Given a binary search tree (BST), find the lowest common ancestor (LCA) of two given nodes in the BST. According to the definition of LCA on Wikipedia: “The lowest common ancestor is defined between two nodes v and w as the lowest node in T that has			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0bypG9M.html" rel="bookmark">LeetCode OJ：Lowest Common Ancestor of a Binary Tree（最近公共祖先）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Given a binary tree, find the lowest common ancestor (LCA) of two given nodes in the tree. According to the definition of LCA on Wikipedia: “The lowest common ancestor is defined between two nodes v and w as the lowest node in T that has both v and w			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0knNREM.html" rel="bookmark">leetcode -  Lowest Common Ancestor of a Binary Search Tree</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				leetcode -  Lowest Common Ancestor of a Binary Search Tree Given a binary search tree (BST), find the lowest common ancestor (LCA) of two given nodes in the BST. According to the definition of LCA on Wikipedia: “The lowest common ancestor is defined			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4QWvqB0.html" rel="bookmark">LeetCode235&mdash;&mdash;Lowest Common Ancestor of a Binary Search Tree</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Given a binary search tree (BST), find the lowest common ancestor (LCA) of two given nodes in the BST. According to the definition of LCA on Wikipedia: &quot;The lowest common ancestor is defined between two nodes v and w as the lowest node in T that has			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Z0KyzJ4.html" rel="bookmark" class="title">跟着百度学PHP&lbrack;11&rsqb;-PHP当中的异常处理</a>
					<div>
						首先要说一下常见的三种错误: 1.语法错误 2.运行错误 3.逻辑错误 00x1 错误报告及错误级别 PHP的错误分为三个等级 1.注意(notice)   没有变量a 2.警告(warning) 没 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/k0e69a3.html" rel="bookmark" class="title">Unity3d使用蓝牙&lpar;bluetooth&rpar;开发IOS点对点网络游戏</a>
					<div>
						著作权声明:本文由http://www.cnblogs.com/icker 原创,欢迎转载分享.转载时请保留该声明和作者博客链接,谢谢! 最近使用Unity3d制作的IOS游戏需要加入联网对战功能功能 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3ZV1ZG3.html" rel="bookmark" class="title">Struts2&lpar;十六&rpar;Json</a>
					<div>
						一.JSON Json就是浏览器和服务器之间交换数据的一种轻量级对象 javaSctipt中类似的对象操作 $(function() { var person = { &quot;name&quot; ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4JD57Y0.html" rel="bookmark" class="title">tomcat配置虚拟主机</a>
					<div>
						在眼下,非常多server都是一台server对外能够訪问非常多个javaEE的项目,这样的实现方式就须要在tomcat里面配置虚拟主机了!以下就说说怎样配置虚拟主机: 找到tomcat的安装文件夹, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/38ZjvnM.html" rel="bookmark" class="title">Cocoapods 制作发布</a>
					<div>
						CocoaPods是一个负责管理iOS项目中第三方开源库的工具.CocoaPods的项目在Github上管理. 1.首先查看自己的cocoapods版本,也可以查看pod是否支持trunk命令 pod ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MG8KB60.html" rel="bookmark" class="title">主动訪问用户数据的背后是品牌战略</a>
					<div>
						前段时间,百度站长平台公布了一个消息,消息称广大的站长朋友非常easy忽略一些用户主动訪问的数据.事实上在笔者觉得.这是百度側面的反馈给广大站长朋友的一个信号,就是告诉广大站长朋友应该多注重品牌宣传. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/415rAO4.html" rel="bookmark" class="title">蒲恐磕仄奈m41fgm525</a>
					<div>
						http://imgur.com/a/MA1sEhttp://group.jd.com/thread/20000001/20119413/20001239.htmhttp://imgur.com/a/ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0kZoajM.html" rel="bookmark" class="title">RHEL6&period;5及Win7的和谐共处（投机版）</a>
					<div>
						背景: 在Windows XP存在时,装了个RHEL6.5,用的是安装程序自带的Grub,后来将XP删除后重装了Windows7,RHEL的Grub被覆盖,启动不了RHEL了,于是补上RHEL的引导… ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MPWJBn4.html" rel="bookmark" class="title">java web中servlet、jsp、html 互相访问的路径问题。</a>
					<div>
						在java web种经常出现 404找不到网页的错误,究其原因,一般是访问的路径不对. java web中的路径使用按我的分法可以分两种情况,当然啦两者使用相对路径是一致,本文只说绝对路径. 情况一. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3ZrOeZ3.html" rel="bookmark" class="title">&lbrack;2014百度之星资格赛&rsqb;</a>
					<div>
						第一题: Energy Conversion Problem Description 魔法师百小度也有遇到难题的时候-- 现在,百小度正在一个古老的石门面前,石门上有一段古老的魔法文字,读懂这种魔法文 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MoxO7n0.html" rel="bookmark" class="title">jquery核心的学习进程一</a>
					<div>
						&lt;html&gt;&lt;head&gt;&lt;title&gt;jquery_core&lt;/title&gt;&lt;script src=&quot;http://apps.bdimg ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MgZXaL4.html" rel="bookmark" class="title">iOS之控制器View的加载</a>
					<div>
						首先我们得知道,控制器view是通过懒加载的方式进行加载的,即用到的时候再加载.loadView有什么作用,它与viewDidLoad有何区别. loadView方法 当我们用到控制器view时,就会 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/M65k2X4.html" rel="bookmark" class="title">javascript 中&equals;&equals;与&equals;&equals;&equals;</a>
					<div>
						1.==相等运算符 1.1如果操作数具有相同的类型,则判断其等同性,如果两个数的值相等,则返回true(相等),否则返回 false (不相等) 1.2如果两个操作数类型不同,则按如下规则: null ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MmY9ZKM.html" rel="bookmark" class="title">Python部署虚拟环境的利器&mdash;&mdash;Virtualenv</a>
					<div>
						virtualenv is a tool to create isolated Python environments. virtualenv 是创建独立Python开发环境的工具,用于解决同一台机器 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0ekBap4.html" rel="bookmark" class="title">对象转数组</a>
					<div>
						public function object_to_array(&amp;$object){ //对象转数组 $object=json_decode(json_encode($object),true ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0j2NkW0.html" rel="bookmark" class="title">android 使用gson 处理Json</a>
					<div>
						Json是一种类似于XML的通用数据交换格式,比XML传输效率高.更利于网络传输数据.这里说一些使用Gosn类来处理json数据.Gson比传统的json处理方式更加快速,Gson开源的.如果有兴趣的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MD8JLpM.html" rel="bookmark" class="title">EditText属性</a>
					<div>
						1.EditText输入的文字为密码形式的设置 (1)通过.xml里设置: 把该EditText设为:android:password=&quot;true&quot; // 以&quot;.&quo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MLvVbQ3.html" rel="bookmark" class="title">Ubuntu16&period;04安装Kafka集群</a>
					<div>
						下载 http://kafka.apache.org/downloads.html http://mirror.bit.edu.cn/apache/kafka/0.11.0.0/kafka_2.11- ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0dzEPB4.html" rel="bookmark" class="title">三个技巧助你在运维职业上获得成功</a>
					<div>
						使DevOps和传统IT工作者恰如其分地配合工作,通常是费力不讨好的事. 终端用户希望没有中断的完美体验.为了达到这一目的,终端用户不需要知道运维做了什么工作.正如IT运维和DevOps专家所知道的, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0K878J3.html" rel="bookmark" class="title">Gradle使用手册（二）：项目结构</a>
					<div>
						原文地址:http://tools.android.com/tech-docs/new-build-system/user-guide#TOC-Using-sourceCompatibility-1. ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.022 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
